//  tray.cpp
//
//	tray
//
//	Copyright (c) 2005 N099
//
#include <streams.h>     // DirectShow (includes windows.h)
#include <dvdmedia.h>
#include <tchar.h>

#include "hwdeintdefs.h"
#include "hwdeint.h"

#include "tray.h"
#include "resource.h"

#define TRAYICON 3002
#define MSG_TRAYICON (WM_APP+15)

//window class name
static TCHAR cls_tray[] = TEXT("hwdeint_tray");

//Menu call back
static LRESULT CALLBACK trayWndProc (HWND hwnd, UINT msg, WPARAM wprm, LPARAM lprm)
{
	TrayIcon *ti=(TrayIcon*)GetWindowLong(hwnd,GWL_USERDATA);
	if(msg == MSG_TRAYICON){
		if(!ti) return 0;
		switch (lprm)
		{
		case WM_LBUTTONDBLCLK:
			ti->show_prop();
			return 0;

		case WM_LBUTTONUP:
			ti->hwdf->reset_autodetect();
			return 0;

        case WM_RBUTTONUP:
		case WM_CONTEXTMENU:
			POINT p;
			ti->hwdf->get_cfg_ar(&ti->m_ar);
            ti->hwdf->get_cfg_am2(&ti->m_am2);
			ti->hwdf->get_cfg_vif2(&ti->m_vif2);
			GetCursorPos(&p);
			if(!ti->m_vif2.interlace){
				EnableMenuItem(ti->hMenu, IDM_IMEDIA2, MF_GRAYED);
				EnableMenuItem(ti->hMenu, IDM_WEAVE, MF_GRAYED);
				EnableMenuItem(ti->hMenu, IDM_FIELD1FIRST, MF_GRAYED);
			}else{
				EnableMenuItem(ti->hMenu, IDM_IMEDIA2, MF_ENABLED);
				EnableMenuItem(ti->hMenu, IDM_WEAVE, MF_ENABLED);
				EnableMenuItem(ti->hMenu, IDM_FIELD1FIRST, MF_ENABLED);
			}
			if(ti->m_am2.use_imedia2){
				CheckMenuItem(ti->hMenu, IDM_IMEDIA2, MF_CHECKED);
				EnableMenuItem(ti->hMenu, IDM_WEAVE, MF_ENABLED);
				EnableMenuItem(ti->hMenu, IDM_FIELD1FIRST, MF_ENABLED);
			}else{
				CheckMenuItem(ti->hMenu, IDM_IMEDIA2, MF_UNCHECKED);
				EnableMenuItem(ti->hMenu, IDM_FIELD1FIRST, MF_GRAYED);
				EnableMenuItem(ti->hMenu, IDM_WEAVE, MF_GRAYED);
			}
			CheckMenuRadioItem(ti->hMenu, IDM_AR_KEEPORIGINAL, IDM_AR_USERDEFINED,
				IDM_AR_KEEPORIGINAL + ti->m_ar.ar_mode, MF_BYCOMMAND);
			CheckMenuItem(ti->hMenu, IDM_FIELD1FIRST, ti->m_am2.am2_tff ?MF_CHECKED:MF_UNCHECKED);
			CheckMenuItem(ti->hMenu, IDM_WEAVE, ti->m_am2.weave ? MF_CHECKED:MF_UNCHECKED);
			SetForegroundWindow(hwnd);
			TrackPopupMenu(ti->hMenu,TPM_RIGHTALIGN|TPM_BOTTOMALIGN,p.x,p.y,0,hwnd,NULL);
			return 0;
		}
	} else if(msg == WM_COMMAND) {//if(msg==MSG_TRAYICON)
		if(!ti) return 0;
		switch (LOWORD(wprm))
		{
		case IDM_SHOWPROP:
			ti->show_prop();
			return 0;
		case IDM_IMEDIA2:
			ti->m_am2.use_imedia2 = !ti->m_am2.use_imedia2;
			ti->hwdf->set_cfg_am2(ti->m_am2);
			break;
		case IDM_FIELD1FIRST:
			ti->m_am2.am2_tff = !ti->m_am2.am2_tff;
			ti->hwdf->set_cfg_am2(ti->m_am2);
			break;
		case IDM_WEAVE:
			ti->m_am2.weave = !ti->m_am2.weave;
			ti->hwdf->set_cfg_am2(ti->m_am2);
			break;
		case IDM_AR_KEEPORIGINAL:
			ti->m_ar.ar_mode = AR_ORIG;
			ti->hwdf->set_cfg_ar(ti->m_ar);
			break;
		case IDM_AR_43:
			ti->m_ar.ar_mode = AR_43;
			ti->hwdf->set_cfg_ar(ti->m_ar);
			break;
		case IDM_AR_169:
			ti->m_ar.ar_mode = AR_169;
			ti->hwdf->set_cfg_ar(ti->m_ar);
			break;
		case IDM_AR_USERDEFINED:
			ti->m_ar.ar_mode = AR_UD;
			ti->hwdf->set_cfg_ar(ti->m_ar);
			break;
		}
		ti->hwdf->get_cfg_ar(&ti->m_ar);
        ti->hwdf->get_cfg_am2(&ti->m_am2);
		/*
		if(ti->m_am2.use_imedia2){
			CheckMenuItem(ti->hMenu, IDM_IMEDIA2, MF_CHECKED);
			EnableMenuItem(ti->hMenu, IDM_WEAVE, MF_ENABLED);
			EnableMenuItem(ti->hMenu, IDM_FIELD1FIRST, MF_ENABLED);
		}else{
			CheckMenuItem(ti->hMenu, IDM_IMEDIA2, MF_UNCHECKED);
			EnableMenuItem(ti->hMenu, IDM_FIELD1FIRST, MF_GRAYED);
			EnableMenuItem(ti->hMenu, IDM_WEAVE, MF_GRAYED);
		}
		CheckMenuRadioItem(ti->hMenu, IDM_AR_KEEPORIGINAL, IDM_AR_USERDEFINED,
			IDM_AR_KEEPORIGINAL + ti->m_ar.ar_mode, MF_BYCOMMAND);
		CheckMenuItem(ti->hMenu, IDM_FIELD1FIRST, ti->m_am2.am2_tff ?MF_CHECKED:MF_UNCHECKED);
		CheckMenuItem(ti->hMenu, IDM_WEAVE, ti->m_am2.weave ? MF_CHECKED:MF_UNCHECKED);
		*/
		return 0;
	}

	return DefWindowProc(hwnd,msg,wprm,lprm);
}


//constructor
TrayIcon::TrayIcon(CHWDeintFilter *Chwdf)
{
 TCHAR buff[64];

 //_tcscpy(buff, TEXT("HW Deint"));
 LoadString(g_hInst, IDS_HWDeintTray, buff, sizeof(buff));

 WNDCLASS wndclass ;
 wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
 wndclass.lpfnWndProc   = trayWndProc ;
 wndclass.cbClsExtra    = 0 ;
 wndclass.cbWndExtra    = 0 ;
 wndclass.hInstance     = hi = g_hInst;
 wndclass.hIcon         = NULL;
 wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW) ;
 wndclass.hbrBackground = GetSysColorBrush(COLOR_BTNFACE);
 wndclass.lpszMenuName  = NULL ;
 wndclass.lpszClassName = cls_tray;
 ha=RegisterClass(&wndclass);

 h=CreateWindow(
                cls_tray,                   // window class name
                buff,            // window caption
                WS_OVERLAPPED|WS_BORDER|WS_SYSMENU|WS_MINIMIZEBOX,
                CW_USEDEFAULT,              // initial x position
                CW_USEDEFAULT,              // initial y position
                1,                          // initial x size
                1,                          // initial y size
                NULL,                       // parent window handle
                NULL,                       // window menu handle
                hi,                         // program instance handle
                NULL
               );                     

 //NOTIFYICONDATA
 nid.cbSize=sizeof(nid);
 nid.hWnd=h;
 nid.uID=TRAYICON;
 nid.uFlags=NIF_ICON|NIF_TIP|NIF_MESSAGE;
 nid.hIcon=(HICON)LoadImage(hi, MAKEINTRESOURCE(IDI_HWICON),
	 IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
 //nid.hIcon=LoadIcon(hi,MAKEINTRESOURCE(IDI_HWICON));
 nid.uCallbackMessage=MSG_TRAYICON;
 _tcscpy(nid.szTip, buff);

 //Menu
 hMenu = LoadMenu(hi, MAKEINTRESOURCE(IDR_HWDMENU));
 hMenu = GetSubMenu(hMenu, 0);

 visible = false;
 prop_shown = false;

 //hwdeint
 hwdf = Chwdf;
 if(NULL != hwdf){
	SetWindowLong(h,GWL_USERDATA,LONG(this));

	hwdf->get_cfg_ar(&m_ar);
	hwdf->get_cfg_am2(&m_am2);
	hwdf->get_cfg_vif2(&m_vif2);

	visible = hwdf->is_tray_visible();
	if(visible){
		 Shell_NotifyIcon(NIM_ADD,&nid);
	}
 }

 DbgLog((LOG_TRACE, 2, TEXT("TrayIcon::TrayIcon")));
}

//destructor
TrayIcon::~TrayIcon()
{
 Shell_NotifyIcon(NIM_DELETE,&nid);
 DestroyWindow(h);
 UnregisterClass(cls_tray,hi);
 DbgLog((LOG_TRACE, 2, TEXT("TrayIcon::~TrayIcon")));
}

void TrayIcon::show(void)
{
 if (!visible)
  {
   Shell_NotifyIcon(NIM_ADD,&nid);
   visible=true;
  }; 
}

void TrayIcon::hide(void)
{
 if (visible)
  {
   Shell_NotifyIcon(NIM_DELETE,&nid);
   visible=false;
  }; 
}

//display property pages
void TrayIcon::show_prop(void){
	HWND hwnd = h;
	CBaseFilter *pFilter = hwdf;
	ISpecifyPropertyPages *pProp;
	HRESULT hr = E_FAIL;

	if(NULL != pFilter && !prop_shown){
		hr = pFilter->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pProp);
	}
	if (SUCCEEDED(hr)) 
	{
		// tB^̖O IUnknown |C^擾B
		FILTER_INFO FilterInfo;
		hr = pFilter->QueryFilterInfo(&FilterInfo); 
		IUnknown *pFilterUnk;
		pFilter->QueryInterface(IID_IUnknown, (void **)&pFilterUnk);

		// y[W\B
		CAUUID caGUID;
		pProp->GetPages(&caGUID);
		pProp->Release();

		prop_shown = true;

		OleCreatePropertyFrame(
			hwnd,                   // eEBhEB
			0, 0,                   // \ς݁B
			FilterInfo.achName,     // _CAO {bNX̃LvVB
			1,                      // IuWFNg (tB^̂)B
			&pFilterUnk,            // IuWFNg |C^̔zB
			caGUID.cElems,          // vpeB y[WB
			caGUID.pElems,          // vpeB y[W CLSID ̔zB
			0,                      // P[ʎqB
			0, NULL                 // \ς݁B
		);

		prop_shown = false;

		// N[ AbvB
		pFilterUnk->Release();
		FilterInfo.pGraph->Release();
		CoTaskMemFree(caGUID.pElems);
	}
}


