//  util.cpp
//
//	reg utility functions
//
//	Copyright (c) 2005 N099
//
#include <windows.h>
#include <streams.h>

#include <vector>
#include <algorithm>
#include <tchar.h>
#include <atlbase.h>

#include "util.h"

using namespace std;

// `FbN for LoadRegistryInfo()
// ret : RegQueryValueEx()̕Ԃl
// val : ǂݍ񂾒l
// min : LȍŒl
// max : Lȍől
// def : ftHgl
static int chkval_l(DWORD ret, DWORD val, int min, int max, int def)
{
	ASSERT(min <= max);

	if(ret == ERROR_SUCCESS){
		if(val>=min && val<=max){
			return val;
		}
	}

	return def;
}

// WXgǂݍ
void LoadRegistryInfo(CONFIG *conf)
{
	HKEY hKey;
	DWORD val;
	DWORD size = sizeof(DWORD);
	LONG ret;
	RegOpenKeyEx(HWDI_REG_KEY, HWDI_REG_SUBKEY, 0, KEY_READ, &hKey);
 

	//video info2
	ret = RegQueryValueEx(hKey, _T("VIF2_interlace"), NULL, NULL, (LPBYTE)&val, &size);
	conf->vif2.interlace = chkval_l(ret, val, 0, 1, 0);

	ret = RegQueryValueEx(hKey, _T("VIF2_tff"), NULL, NULL, (LPBYTE)&val, &size);
	conf->vif2.vif_tff = chkval_l(ret, val, 0, 1, 0);

	ret = RegQueryValueEx(hKey, _T("VIF2_disp_mode"), NULL, NULL, (LPBYTE)&val, &size);
	conf->vif2.disp_mode = chkval_l(ret, val, 0, 2, 0);

	//am media type2
	ret = RegQueryValueEx(hKey, _T("AM2_use_imedia2"), NULL, NULL, (LPBYTE)&val, &size);
	conf->am2.use_imedia2 = chkval_l(ret, val, 0, 1, 0);

	ret = RegQueryValueEx(hKey, _T("AM2_tff"), NULL, NULL, (LPBYTE)&val, &size);
	conf->am2.am2_tff = chkval_l(ret, val, 0, 1, 0);

	ret = RegQueryValueEx(hKey, _T("AM2_weave"), NULL, NULL, (LPBYTE)&val, &size);
	conf->am2.weave = chkval_l(ret, val, 0, 1, 0);
	
	//aspect ratio
	ret = RegQueryValueEx(hKey, _T("AR_mode"), NULL, NULL, (LPBYTE)&val, &size);
	conf->ar.ar_mode = chkval_l(ret, val, 0, AR_UD, AR_ORIG);

	ret = RegQueryValueEx(hKey, _T("AR_h"), NULL, NULL, (LPBYTE)&val, &size);
	conf->ar.ar_h = chkval_l(ret, val, 1, INT_MAX, AR_H_DEF);

	ret = RegQueryValueEx(hKey, _T("AR_v"), NULL, NULL, (LPBYTE)&val, &size);
	conf->ar.ar_v = chkval_l(ret, val, 1, INT_MAX, AR_V_DEF);

	//misc
	ret = RegQueryValueEx(hKey, _T("ShowTrayIcon"), NULL, NULL, (LPBYTE)&val, &size);
	conf->misc.tray = chkval_l(ret, val, 0, 1, 1);

	ret = RegQueryValueEx(hKey, _T("cnv_upstream"), NULL, NULL, (LPBYTE)&val, &size);
	conf->misc.conv_upstream = chkval_l(ret, val, 0, 1, 1);

	ret = RegQueryValueEx(hKey, _T("not_connect_i"), NULL, NULL, (LPBYTE)&val, &size);
	conf->misc.not_connect_iflg = chkval_l(ret, val, 0, 1, 1);

	ret = RegQueryValueEx(hKey, _T("copy_always"), NULL, NULL, (LPBYTE)&val, &size);
	conf->misc.copy_always = chkval_l(ret, val, 0, 1, 0);

	//color
	ret = RegQueryValueEx(hKey, _T("colorspace"), NULL, NULL, (LPBYTE)&val, &size);
	conf->colorspace = chkval_l(ret, val, 0, TYPE_ALL+(TYPE_ALL>>2), TYPE_ALL);

	//auto detection
	ret = RegQueryValueEx(hKey, _T("AD_field"), NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.field = chkval_l(ret, val, 0, 1, 0);

	ret = RegQueryValueEx(hKey, _T("AD_flip"), NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.field_flip = chkval_l(ret, val, 0, 1, 0);

	ret = RegQueryValueEx(hKey, _T("AD_interlace"), NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.interlace = chkval_l(ret, val, 0, 1, 0);

	ret = RegQueryValueEx(hKey, _T("AD_i_percent"), NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.i_percent = chkval_l(ret, val, AD_MIN_PERCENT_TH, AD_MAX_PERCENT_TH, AD_DEF_PERCENT);

	ret = RegQueryValueEx(hKey, _T("AD_core"), NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.core = chkval_l(ret, val, AD_MIN_CORE_TH, AD_MAX_CORE_TH, AD_DEF_CORE);

	ret = RegQueryValueEx(hKey, _T("AD_duration"), NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.duration = chkval_l(ret, val, 0, INT_MAX, AD_DEF_DURATION);

	ret = RegQueryValueEx(hKey, _T("AD_e_term"), NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.e_term = chkval_l(ret, val, 1, INT_MAX, AD_DEF_ETERM);

	ret = RegQueryValueEx(hKey, _T("AD_SSE"), NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.sse = chkval_l(ret, val, 0, 1, 1);

	ret = RegQueryValueEx(hKey, _T("AD_VISUAL"), NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.vis = chkval_l(ret, val, 0, 1, 0);

	RegCloseKey(hKey);
}

// `FbN for SaveRegistryInfo()
// val : ݂l
// min : LȍŒl
// max : Lȍől
// def : ftHgl
static DWORD chkval_s(DWORD val, int min, int max, int def)
{
	ASSERT(min <= max);

	if(val>=min && val<=max){
		return val;
	}

	return def;
}

//WXgɃZ[u
void SaveRegistryInfo(CONFIG &conf)
{
	HKEY hKey;
	DWORD dispo, val;

	if (RegCreateKeyEx(
			HWDI_REG_KEY,
			HWDI_REG_SUBKEY,
			0,
			HWDI_REG_CLASS,
			REG_OPTION_NON_VOLATILE,
			KEY_WRITE,
			0, 
			&hKey, 
			&dispo) != ERROR_SUCCESS)
	{
		OutputDebugString(NAME("SaveRegistryInfo:Couldn't create HWDI_REG_SUBKEY"));
		return;
	}

	// check value & save
	val = chkval_s(conf.vif2.interlace, 0, 1, 0);
	RegSetValueEx(hKey, _T("VIF2_interlace"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.vif2.vif_tff, 0 ,1, 0);
	RegSetValueEx(hKey, _T("VIF2_tff"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.vif2.disp_mode, 0, 2, 0);
	RegSetValueEx(hKey, _T("VIF2_disp_mode"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.am2.use_imedia2, 0, 1, 0);
	RegSetValueEx(hKey, _T("AM2_use_imedia2"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.am2.am2_tff, 0, 1, 0);
	RegSetValueEx(hKey, _T("AM2_tff"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.am2.weave, 0, 1, 0);
	RegSetValueEx(hKey, _T("AM2_weave"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	//aspect ratio
	val = chkval_s(conf.ar.ar_mode, 0, AR_UD, AR_ORIG);
	RegSetValueEx(hKey, _T("AR_mode"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.ar.ar_h, 1, INT_MAX, AR_H_DEF);
	RegSetValueEx(hKey, _T("AR_h"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.ar.ar_v, 1, INT_MAX, AR_V_DEF);
	RegSetValueEx(hKey, _T("AR_v"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	//misc
	val = chkval_s(conf.misc.tray, 0, 1, 1);
	RegSetValueEx(hKey, _T("ShowTrayIcon"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.misc.conv_upstream, 0, 1, 1);
	RegSetValueEx(hKey, _T("cnv_upstream"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.misc.not_connect_iflg, 0, 1, 1);
	RegSetValueEx(hKey, _T("not_connect_i"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.misc.copy_always, 0, 1, 0);
	RegSetValueEx(hKey, _T("copy_always"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	//color
	val = chkval_s(conf.colorspace, 0, TYPE_ALL+(TYPE_ALL>>2), TYPE_ALL);
	RegSetValueEx(hKey, _T("colorspace"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	//auto detection
	val = chkval_s(conf.ad.field, 0, 1, 0);
	RegSetValueEx(hKey, _T("AD_field"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.ad.field_flip, 0, 1, 0);
	RegSetValueEx(hKey, _T("AD_flip"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.ad.interlace, 0, 1, 0);
	RegSetValueEx(hKey, _T("AD_interlace"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.ad.core, AD_MIN_CORE_TH, AD_MAX_CORE_TH, AD_DEF_CORE);
	RegSetValueEx(hKey, _T("AD_core"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));
	
	val = chkval_s(conf.ad.i_percent, AD_MIN_PERCENT_TH, AD_MAX_PERCENT_TH, AD_DEF_PERCENT);
	RegSetValueEx(hKey, _T("AD_i_percent"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.ad.duration, 0, INT_MAX, AD_DEF_DURATION);
	RegSetValueEx(hKey, _T("AD_duration"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.ad.e_term, 1, INT_MAX, AD_DEF_ETERM);
	RegSetValueEx(hKey, _T("AD_e_term"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.ad.sse, 0, 1, 1);
	RegSetValueEx(hKey, _T("AD_SSE"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = chkval_s(conf.ad.vis, 0, 1, 0);
	RegSetValueEx(hKey, _T("AD_VISUAL"), 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));


	RegCloseKey(hKey);
}

void LoadDSFlist(vector<dsfid> &list)
{
	HKEY  hKey;
	DWORD size;
	DWORD type;
	LONG  ret = ERROR_SUCCESS;
	LONG  ret2 = ERROR_SUCCESS;
	TCHAR s[16];
	BYTE *buf;

	RegOpenKeyEx(HWDI_REG_KEY, HWDI_REG_SUBKEY_DSF, 0, KEY_READ, &hKey);

	list.clear();

	for(int i=0; ret==ERROR_SUCCESS || ret2==ERROR_SUCCESS; ++i){
		dsfid di;
		//load CLSID
		_stprintf(s, _T("CLSID%.3d"), i);
		ret = RegQueryValueEx(hKey, s, NULL, &type, NULL, &size);
		if(ret == ERROR_SUCCESS && type == REG_SZ){
			buf = new(nothrow) BYTE[size];
			if(!buf) break;
			ZeroMemory(buf, size);
			ret = RegQueryValueEx(hKey, s, NULL, NULL, (LPBYTE)buf, &size);
			if(ret == ERROR_SUCCESS){
				if(_tcslen((LPCTSTR)buf)>0){
					CT2W c((LPCTSTR)buf);
					di.setCLSID(c);
				}
			}
			delete[] buf;
		}
		//load NAME
		_stprintf(s, _T("NAME%.3d"), i);
		ret2 = RegQueryValueEx(hKey, s, NULL, &type, NULL, &size);
		if(ret2 == ERROR_SUCCESS && type == REG_SZ){
			buf = new(nothrow) BYTE[size];
			if(!buf) break;
			ZeroMemory(buf, size);
			ret2 = RegQueryValueEx(hKey, s, NULL, NULL, (LPBYTE)buf, &size);
			if(ret2 == ERROR_SUCCESS){
				if(_tcslen((LPCTSTR)buf)>0){
					CT2W c((LPCTSTR)buf);
					di.setNAME(c);
				}
			}
			delete[] buf;
		}
		if(di.hasCLSID() || di.hasNAME()){
			list.push_back(di);
		}
	}
	sort(list.begin(), list.end());
	vector<dsfid>::iterator p = unique(list.begin(), list.end());
	list.erase(p, list.end());
	

	DbgLog((LOG_TRACE, 3, TEXT("LoadDSFlist:Loaded %d DSFs"), i-1));

	RegCloseKey(hKey);
}

void SaveDSFlist(vector<dsfid> &list)
{
	HKEY hKey;
	DWORD dispo;
	TCHAR s[16];
	TCHAR s_null[] = TEXT("");
	DWORD sz_s;
	BYTE buf[MAX_FILTER_NAME*sizeof(TCHAR)];
	LONG  ret = ERROR_SUCCESS;
	int i = 0;

	ASSERT(MAX_FILTER_NAME > CHARS_IN_GUID+1);

	if (RegCreateKeyEx(
			HWDI_REG_KEY,
			HWDI_REG_SUBKEY_DSF,
			0,
			HWDI_REG_CLASS,
			REG_OPTION_NON_VOLATILE,
			KEY_WRITE | KEY_READ,
			0, 
			&hKey, 
			&dispo) != ERROR_SUCCESS)
	{
		OutputDebugString(NAME("SaveDSFlist:Couldn't create HWDI_REG_SUBKEY_DSF"));
		return;
	}

	// clear all entries
	while(ret==ERROR_SUCCESS){
		sz_s = 16;
		ret = RegEnumValue(hKey, 0, s, &sz_s, NULL, NULL, NULL, NULL);
		if(ret == ERROR_SUCCESS){
			ret = RegDeleteValue(hKey, s);
		}
	}

	// save list
	vector<dsfid>::iterator p = list.begin();
	while(p != list.end()){
		//save name
		_stprintf(s, _T("NAME%.3d"), i);
		ZeroMemory(buf, sizeof(buf));
		if(p->hasNAME()){
			CW2CT c(p->c_str_name());
			_tcsncpy((TCHAR *)buf, c, MAX_FILTER_NAME);
		}else{
			_tcsncpy((TCHAR *)buf, s_null, MAX_FILTER_NAME);
		}
		RegSetValueEx(hKey, s, 0, REG_SZ, 
			(const BYTE*)buf, (sizeof(TCHAR) * _tcslen((LPCTSTR)buf))+1);
		//save CLSID
		_stprintf(s, _T("CLSID%.3d"), i);
		ZeroMemory(buf, sizeof(buf));
		if(p->hasCLSID()){
			CW2CT c(p->c_str_cls());
			_tcsncpy((TCHAR *)buf, c, MAX_FILTER_NAME);
		}else{
			_tcsncpy((TCHAR *)buf, s_null, MAX_FILTER_NAME);
		}
		RegSetValueEx(hKey, s, 0, REG_SZ,
			(const BYTE*)buf, (sizeof(TCHAR) * _tcslen((LPCTSTR)buf))+1);
		++i;
		++p;
		if(i>100) break; //max 100 for safe
	}

	DbgLog((LOG_TRACE, 3, NAME("SaveDSFlist:Saved %d DSFs"), i));

	RegCloseKey(hKey);
}

